---
title: 'Window: pageshow event'
slug: Web/API/Window/pageshow_event
tags:
  - API
  - Document
  - Event
  - History
  - Navigation
  - Page
  - PageTransitionEvent
  - Reference
  - Window
  - pageshow
  - show
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>pageshow</code></strong> event is sent to a {{domxref("Window")}} when the browser displays the window's document due to navigation.</span> This includes:</p>

<ul>
 <li>Initially loading the page</li>
 <li>Navigating to the page from another page in the same window or tab</li>
 <li>Restoring a frozen page on mobile OSes</li>
 <li>Returning to the page using the browser's forward or back buttons</li>
</ul>

<div class="notecard note">
<p>During the initial page load, the <code>pageshow</code> event fires <em>after</em> the {{domxref("Window/load_event", "load")}} event.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PageTransitionEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("Window.onpageshow", "onpageshow")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This example sets up event handlers for events listed in the array <code>events</code>. The handler, <code>eventLogger()</code>, logs the type of event that occurred to the console, and includes the value of the {{domxref("PageTransitionEvent.persisted", "persisted")}} flag on <code>pageshow</code> and <code>pagehide</code> events.</p>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const events = [
  "pagehide", "pageshow",
  "unload", "load"
];

const eventLogger = event =&gt; {
  switch (event.type) {
    case "pagehide":
    case "pageshow":
      let isPersisted = event.persisted ? "persisted" : "not persisted";
      console.log('Event:', event.type, '-', isPersisted);
      break;
    default:
      console.log('Event:', event.type);
      break;
  }
};

events.forEach(eventName =&gt;
  window.addEventListener(eventName, eventLogger)
);</pre>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;Open the console and watch the output as you navigate to and from
this page. Try loading new pages into this tab, then navigating forward
and backward through history, noting the events’ output to the log.&lt;/p&gt;
</pre>

<h3 id="Results">Results</h3>

<p>{{EmbedLiveSample("Examples", 640, 250)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'browsing-the-web.html#event-pageshow', 'pageshow')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial specification.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'browsers.html#event-pageshow', 'pageshow')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.pageshow_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Window.pagehide_event", "pagehide")}}</li>
</ul>
